<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">

    <modelVersion>4.0.0</modelVersion>

    <parent>
        <groupId>de.darcoweb</groupId>
        <artifactId>VaroPlugin</artifactId>
        <version>1.4.1</version>
    </parent>

    <groupId>de.darcoweb.varoplugin</groupId>
    <artifactId>SpigotPlugin</artifactId>
    <version>${project.parent.version}</version>


    <!-- PLUGINS AND THEIR RESPECTIVE REPOSITORIES -->

    <pluginRepositories>
        <pluginRepository>
            <id>sonatype-repo</id>
            <url>https://oss.sonatype.org/content/repositories/snapshots</url>
            <releases>
                <enabled>false</enabled>
            </releases>
            <snapshots>
                <enabled>true</enabled>
            </snapshots>
        </pluginRepository>
    </pluginRepositories>

    <build>
        <finalName>VaroPlugin-${project.version}-SE${java.version}</finalName>

        <plugins>
            <plugin>
                <groupId>org.bsc.maven</groupId>
                <artifactId>maven-processor-plugin</artifactId>
                <version>2.2.4</version>
                <executions>
                    <!-- Run annotation processors on src/main/java sources -->
                    <execution>
                        <id>process</id>
                        <goals>
                            <goal>process</goal>
                        </goals>
                        <phase>generate-sources</phase>
                        <configuration>
                            <outputDirectory>target/generated-sources</outputDirectory>
                            <processors>
                                <processor>de.darcoweb.varoplugin.annotations.processors.MessageListProcessor</processor>
                            </processors>
                        </configuration>
                    </execution>
                </executions>
            </plugin>

            <plugin>
                <groupId>org.codehaus.mojo</groupId>
                <artifactId>build-helper-maven-plugin</artifactId>
                <version>1.9.1</version>
                <executions>
                    <execution>
                        <id>add-source</id>
                        <phase>generate-sources</phase>
                        <goals>
                            <goal>add-source</goal>
                        </goals>
                        <configuration>
                            <sources>
                                <source>target/generated-sources</source>
                            </sources>
                        </configuration>
                    </execution>
                </executions>
            </plugin>

            <!-- Disable annotation processors during normal compilation -->
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>3.3</version>
                <configuration>
                    <compilerVersion>1.8</compilerVersion>
                    <source>1.8</source>
                    <target>1.8</target>

                    <compilerArgs>
                        <!-- <arg>-proc:none</arg> -->
                    </compilerArgs>
                </configuration>
            </plugin>
        </plugins>
    </build>


    <!-- MAIN DEPENDENCIES AND REPOSITORIES -->

    <repositories>
        <repository>
            <id>spigot-repo</id>
            <url>https://hub.spigotmc.org/nexus/content/groups/public/</url>
        </repository>
    </repositories>


    <dependencies>
        <dependency>
            <groupId>de.darcoweb.varoplugin</groupId>
            <artifactId>AnnotationProcessors</artifactId>
            <version>${project.parent.version}</version>
            <scope>compile</scope>
        </dependency>

        <dependency>
            <groupId>de.darcoweb.varoplugin</groupId>
            <artifactId>Annotations</artifactId>
            <version>${project.parent.version}</version>
            <scope>provided</scope>
            <!-- The interfaces implemented need to exist at runtime too. -->
        </dependency>

        <dependency>
            <groupId>org.spigotmc</groupId>
            <artifactId>spigot-api</artifactId>
            <version>LATEST</version>
        </dependency>

        <!-- Only for testing purposes ->
        <dependency>
            <groupId>org.spigotmc</groupId>
            <artifactId>spigot</artifactId>
            <version>1.8.3-R0.1-SNAPSHOT</version>
        </dependency>
        <!- -->

        <dependency>
            <groupId>org.projectlombok</groupId>
            <artifactId>lombok</artifactId>
            <version>1.16.4</version> <!-- Is the specification of the version needed? see dependenyManagement tag.. -->
        </dependency>
    </dependencies>
</project>